#!/usr/bin/python
# -*- coding: utf-8 -*-

import os
import time
import array

from ... import ftdi

from .apg7300base import APG7300Base
from .config import config
from .status import status
from .histogram import Histogram


#########################################################
class APG7300(APG7300Base):
    #########################################################
    @staticmethod
    def OpenDeviceByIndex(index):
        object0 = APG7300()
        result = object0.OpenByIndex(index)

        if object0.isSuccess(result) == True:
            object0.GetDeviceInfoList()
        else:
            object0 = None

        return object0

    #########################################################
    @staticmethod
    def OpenDeviceBySerialNumber(serialnumber):
        object0 = APG7300()
        result = object0.OpenBySerialNumber(serialnumber)

        if object0.isSuccess(result) == True:
            object0.GetDeviceInfoList()
        else:
            object0 = None

        return object0

    #########################################################
    def __init__(self):
        super(APG7300, self).__init__()
        self.__initialize()

    #########################################################
    def __initialize(self, parentRun=False):
        if parentRun == True:
            super(APG7300, self)._APG7300Base_initialize()

    #########################################################
    def createConfigObject(self):
        return config(self)

    #########################################################
    def createStatusObject(self):
        return status(self)

    #########################################################
    def createHistogramObject(self):
        return Histogram(self)


#########################################################
def startup():
    result = APG7300.SetProductID()
    return result


#########################################################
def cleanup():
    result = APG7300Base.ResetProductID()
    return result
