#!/usr/bin/python
# -*- coding: utf-8 -*-

import ctypes

from . import constant
from ... import num

DIGIT_PER_NSEC = 40

class common(object):
    #########################################################
    @staticmethod
    def __generateCommand(command, channel=constant.CHNUM_COM):
        newCommand = None
        tempNumber = bytearray(str(channel - 1), encoding="utf-8")

        if channel == constant.CHNUM_COM:
            newCommand = bytearray(command[0:4], encoding="utf-8")
        elif channel == constant.CHNUM_1ST:
            newCommand = bytearray(command[0:3], encoding="utf-8")

            if command == "IFG" or command == "IOF":
                newCommand.append(0x30)  #'0'
            else:
                newCommand.append(0x57)  #'W'
        else:
            newCommand = None

        return newCommand

    #########################################################
    @staticmethod
    def generateCommand(command, value, channel=constant.CHNUM_COM):
        value0 = common.__generateCommand(command, channel)
        value_ = num.byteorder.htonl(value)
        value1 = num.bitconverter.getBytesInt32(value_)
        genCommand = value0 + value1
        return genCommand

    #########################################################
    @staticmethod
    def analyzeCommand(command0, toHostByteorder=True):
        command = command0[0:4].decode()
        value = num.bitconverter.toIntU32(command0, 4)
        value = value if toHostByteorder != True else num.byteorder.ntohl(value)
        return command, value

    #########################################################
    @staticmethod
    def convertTimeDigitToSeconds(digit):
        nsec = float(digit * DIGIT_PER_NSEC)
        sec = nsec / 1000000000.0
        return sec

    #########################################################
    @staticmethod
    def convertTimeSecondToDigits(sec):
        return common.convertTimeMillisecondToDigits(sec * 1000.0)

    @staticmethod
    def convertTimeMillisecondToDigits(msec):
        value0 = msec * 1000000.0
        digit = int(value0 / DIGIT_PER_NSEC)
        return digit
