#!/usr/bin/python
# -*- coding: utf-8 -*-

import os
import sys
import ctypes
from ctypes import *


#####################################################
def initSysconfig():
    if os.name == "nt":
        result = OS_TYPE_WINDOWS
    elif os.name == "posix":
        result = OS_TYPE_LINUX
    else:
        result = OS_TYPE_UNKNOWN

    return result


#####################################################
OS_TYPE_UNKNOWN = 0x0000
OS_TYPE_WINDOWS = 0x0100
OS_TYPE_LINUX = 0x0200

IS_64BIT = True if sys.maxsize > 2**32 else False
IS_32BIT = not IS_64BIT


#####################################################
def getOperatingSystem():
    return THISMACHINE2OS


#####################################################
THISMACHINE2OS = initSysconfig()
